Package: testPackage
Title: A Testing Package Only
Version: 0.0.0.9000
Authors@R: 
    person("First", "Last", , "first.last@example.com", role = c("aut", "cre"),
           comment = c(ORCID = "YOUR-ORCID-ID"))
Maintainer: Dummy <dummy@example.com>
Author: Dummy <dummy@example.com>
Description: What the package does (one paragraph).
License: MIT + file LICENSE
Encoding: UTF-8
Roxygen: list(markdown = TRUE, 
         roclets = c("collate", "rd", "namespace", "doctest::dt_roclet")) 
RoxygenNote: 7.2.3
Suggests: testthat

#' Return a palindrome
#'
#' @return A string
#' @export
#'
#' @doctest
#' p <- palindrome()
#' @expectRaw match(p, "Panama")
#' @omit
#' print(p)
#' @resume
#' pal_letters <- p |>
#'   tolower() |>
#'   (\(x) gsub("[^A-z]", "", x))() |>
#'   strsplit("") |>
#'   unlist()
#' @expectRaw equal(pal_letters, rev(pal_letters))
palindrome <- function () {
   "A man, a plan, a canal - Panama"
}


#' @export
#' @rdname palindrome
#' @doctest palindrome_letters
#' @testRaw skip_on_cran()
#' @expect equal(., rev(.))
#' tenet <- palindrome_letters()
palindrome_letters <- function () {
  c("t", "e", "n", "e", "t")
}

#' Safe mean
#'
#' @param x Numeric vector
#'
#' @return Mean of `x`
#'
#' @export
#'
#' @doctest
#' x <- 1:3
#' @expect equal(2)
#' safe_mean(x)
#'
#' @doctest safe-mean-errors
#'
#' @expect warning("not numeric")
#' safe_mean("a")
#'
#' @expect warning("NA elements")
#' safe_mean(c(1, NA))
safe_mean <- function (x) {
  if (length(x) == 0L) stop("No elements in x")
  if (! is.numeric(x)) warning("x is not numeric")
  if (any(is.na(x))) warning("x contains NA elements")
  mean(x)
}


#' Safe variance
#'
#' @param x A number
#'
#' @return Variance of `x`
#' @export
#'
#' @doctest
#' x <- 1:5
#'
#' @expect length(1)
#' safe_var(x)
safe_var <- function (x) {
  if (length(x) == 0L) stop("No elements in x")
  if (! is.numeric(x)) stop("x is not numeric")
  if (any(is.na(x))) warning("x contains NA elements")
  stats::var(x)
}


#' Add two numbers
#'
#' @param x,y Numbers
#'
#' @return The sum of x and y
#' @export
#'
#' @doctest
#'
#' @expect equal(add(1, 1))
#' 1 + 1
#'
add <- function (x, y) {
  x + y
}


#' Add two numbers with an operator
#'
#' @param x,y Numbers
#'
#' @return The sum of x and y
#' @export
#'
#' @doctest
#' @expect equal(4)
#' 2 %plus% 2
`%plus%` <- function (x, y) {
  x+y
}

expect_roxygen2_output <- function(...) {
  if (packageVersion("roxygen2") > "7.2.3") {
    expect_message(...)
  } else {
    expect_warning(...)
  }
}

test_that("@examples tag", {
  examples_expectation <- "
                           #' @examples
                           #' 1
                           #' @doctest
                           #' @snap
                           #' sum(1, 1)
                           NULL
                          " |> dedent()

  expect_roxygen2_output({
    results <- roc_proc_text(dt_roclet(), examples_expectation)
  }, "@examples")
})


test_that("Tags outside @doctest", {
  outside_expectation <- "
                          #' @expect true()
                          #' TRUE
                          #' @doctest
                          NULL
                         " |> dedent()

  expect_roxygen2_output({
    results <- roc_proc_text(dt_roclet(), outside_expectation)
  }, "@doctest")
})


test_that("Empty @expect tag", {
  empty_expectation <- "
                        #' @doctest
                        #' @expect
                        #' TRUE
                        NULL
                       " |> dedent()

  expect_roxygen2_output({
    results <- roc_proc_text(dt_roclet(), empty_expectation)
  }, "@expect")
})


test_that("Empty @expectRaw tag", {
  empty_expectation <- "
                        #' @doctest
                        #' @expectRaw
                        #' TRUE
                        NULL
                       " |> dedent()

  expect_roxygen2_output({
    results <- roc_proc_text(dt_roclet(), empty_expectation)
  }, "@expectRaw")
})


test_that("Empty @testRaw tag", {
  empty_expectation <- "
                        #' @doctest
                        #' @testRaw
                        #' TRUE
                        NULL
                       " |> dedent()

  expect_roxygen2_output({
    results <- roc_proc_text(dt_roclet(), empty_expectation)
  }, "@testRaw")
})


test_that("assignment", {
  assignment_expectation <- "
                             #' @doctest
                             #' @expect equal(1)
                             #' x <- 1
                             NULL
                            " |> dedent()

  results <- roc_proc_text(dt_roclet(), assignment_expectation)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )
})



test_that("assignment with dot", {
  assignment_dot_expectation <- "
                                 #' @doctest
                                 #' @expect equal(x <- ., rev(x))
                                 #' c('t', 'e', 'n', 'e', 't')
                                 NULL
                                " |> dedent()

  results <- roc_proc_text(dt_roclet(), assignment_dot_expectation)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )
})


test_that("comment", {
  comment_expectation <- "
                          #' @doctest
                          #' @expect equal(4)
                          #' # comment in the way
                          #' 2 + 2
                          NULL
                         " |> dedent()

  results <- roc_proc_text(dt_roclet(), comment_expectation)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )
})



test_that("Multiple @doctest tags", {
  multi_doctest_expectation <- "
                                #' @doctest
                                #' @expect equal(1)
                                #' x <- 1
                                #' @export
                                #' @doctest
                                #' @expect equal(4)
                                #' 2 + 2
                                NULL
                               " |> dedent()

  results <- roc_proc_text(dt_roclet(), multi_doctest_expectation)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )
})



test_that("Multiple @doctest tags, invalid syntax", {
  bad_multi_doctest <- "
                        #' @doctest
                        #' if (TRUE) {
                        #' @expect equal(4)
                        #' 2 + 2
                        #' } else {
                        #' @doctest
                        #' @expect equal(4)
                        #' 2 + 2
                        #' }
                        NULL
                       " |> dedent()

  # We're fine with multiple warnings, so this just checks we got 1
  suppressWarnings(expect_warning(
    roc_proc_text(dt_roclet(), bad_multi_doctest)
  ))
})


test_that("Bad Rd syntax", {
  bad_rd_doctest <- "
                     #' @doctest
                     #' @expect equal(1)
                     #' 1
                     #' if (TRUE) {
                     NULL
                    " |> dedent()

  expect_warning(
    roc_proc_text(dt_roclet(), bad_rd_doctest)
  )
})


test_that("Bad Rd syntax with dontrun", {
  # expectation triggers create_expectations
  bad_dontrun_doctest <- "
                          #' @doctest
                          #' @expect equal(1)
                          #' 1
                          #' \\dontrun{
                          #' if (TRUE) {
                          NULL
                         " |> dedent()

  # We're fine with multiple warnings, so this just checks we got 1
  suppressWarnings(expect_warning(
    roc_proc_text(dt_roclet(), bad_dontrun_doctest)
  ))
})

test_that("@snap", {
  snap_expectation <- "
                       #' @doctest
                       #' @snap
                       #' sum(1, 1)
                       NULL
                      " |> dedent()
  results <- roc_proc_text(dt_roclet(), snap_expectation)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )
})

test_that("@expectation", {
  simple_expectation <- "
                         #' @doctest
                         #' @expect equal(2)
                         #' sum(1, 1)
                         NULL
                        " |> dedent()
  results <- roc_proc_text(dt_roclet(), simple_expectation)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )

  dot_expectation <- "
                      #' @doctest
                      #' @expect equal(., 2)
                      #' sum(1, 1)
                      NULL
                     " |> dedent()
  results <- roc_proc_text(dt_roclet(), dot_expectation)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )

  operator_expectation <- "
                           #' @doctest
                           #' @expect equal( 2)
                           #' 1 + 1
                           NULL
                          " |> dedent()
  results <- roc_proc_text(dt_roclet(), operator_expectation)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )

  namespace_expectation <- "
                            #' @doctest
                            #' @expect equal(., 2)
                            #' base::sum(1, 1)
                            NULL
                           " |> dedent()
  results <- roc_proc_text(dt_roclet(), namespace_expectation)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )

  donttest_expectation <- "
                           #' @doctest
                           #' @expect equal(., 2)
                           #' \\donttest{
                           #' sum(1, 1)
                           #' }
                           NULL
                          " |> dedent()

  results <- roc_proc_text(dt_roclet(), donttest_expectation)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )

  custom_operator_expectation <- "
                                  #' @doctest
                                  #' @expect equal(4)
                                  #' 2 %plus% 2
                                  NULL
                                 " |> dedent()

  results <- roc_proc_text(dt_roclet(),
                                     custom_operator_expectation)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )


  no_follower_expectation <- "
                              #' @doctest
                              #' @expect equal(4)
                              NULL
                             " |> dedent()
  expect_error(
    roc_proc_text(dt_roclet(), no_follower_expectation)
  )

  no_follower_dot_expectation <- "
                                  #' @doctest
                                  #' @expect equal(., 4)
                                  NULL
                                 " |> dedent()
  expect_error(
    roc_proc_text(dt_roclet(), no_follower_dot_expectation)
  )
})

test_that("@testRaw", {
  raw_expectation <- "
                      #' @doctest
                      #' @testRaw skip_on_cran()
                      #' @expect error()
                      #' stop(\"Argh, CRAN won't like it\")
                      NULL
                     " |> dedent()
  results <- roc_proc_text(dt_roclet(), raw_expectation)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )
})

test_that("@doctest", {
    test_ex <- "
                #' @doctest is 1 1?
                #' @expectRaw equal(1, 1)
                #'
                #' @doctest is TRUE true?
                #' @expect true()
                #' TRUE
                NULL
               " |> dedent()
  results <- roc_proc_text(dt_roclet(), test_ex)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )

  test_bad_name <- "
                    #' @doctest three\" {warning('this would be sad');\"
                    #' @expect equal(3)
                    #' 3
                    NULL
                   " |> dedent()
  expect_error(
    roc_proc_text(dt_roclet(), test_bad_name)
  )
})


test_that("empty test", {

  test_empty <- "
                 #' @doctest
                 #' mean(1:3)
                 NULL
                " |> dedent()
  results <- roc_proc_text(dt_roclet(), test_empty)
  expect_output(
    roclet_output(dt_roclet(), results),
    NA  # no output
  )
})


test_that("dontrun", {

  test_dontrun <- "
                   #' @doctest
                   #' \\dontrun{
                   #' @expect error(., 'foo')
                   #' stop('foo')
                   #' }
                   NULL
                  " |> dedent()
  results <- roc_proc_text(dt_roclet(), test_dontrun)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )
})

test_that("@doctestExample", {
  test_ex <- "
              #' Title
              #'
              #' @doctest example from a file
              #' @expect equal(2)
              #' 1 + 1
              #' @doctestExample doctestExample-tester.R
              foo <- function () 1
             " |> dedent()
  results <- roc_proc_text(dt_roclet(), test_ex)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )

  rd_results <- roc_proc_text(rd_roclet(), test_ex)
  expect_snapshot_output(
    print(rd_results)
  )
})

test_that("Rd output", {
  ex <- "
         #' Title
         #'
         #' @doctest
         #' x <- 1
         #' @expect gt(0)
         #' x
         #' @expect lt(0)
         #' -x
         foo <- function() 1
        " |> dedent()

  results <- roc_proc_text(rd_roclet(), ex)
  expect_snapshot_output(
    print(results) # seems to work
  )

  ex_complex <- "
                 #' Title
                 #'
                 #' @doctest
                 #' x <- 1
                 #' if (x > 0) {
                 #' @expect gt(0)
                 #'   x
                 #' } else {
                 #' @expect lt(0)
                 #'   -x
                 #' }
                 foo <- function() 1
                " |> dedent()

  results <- roc_proc_text(rd_roclet(), ex_complex)
  expect_snapshot_output(
    print(results)
  )
})



test_that("dontrun", {

  test_dontrun <- "
                   #' Title
                   #'
                   #' @doctest
                   #' \\dontrun{
                   #' @expect error(., 'foo')
                   #' stop('foo')
                   #' }
                   foo <- 1
                  " |> dedent()
  results <- roc_proc_text(rd_roclet(), test_dontrun)
  expect_snapshot_output(
    print(results)
  )
})


test_that("rd_roclet output", {
  r_file <- file.path("testPackage", "R", "safe-arithmetic.R")
  r_file_text <- readLines(r_file)

  roxygen2::load_options("testPackage")
  expect_silent(
      result <- roxygen2::parse_file(r_file)
  )

  expect_silent(
    result <- roxygen2::roc_proc_text(roxygen2::rd_roclet(), r_file_text)
  )

  setwd("testPackage")
  on.exit(setwd(".."))
  expect_no_error(
    suppressMessages(roxygen2::roxygenise(clean = TRUE))
   )

  expect_snapshot_file(file.path("man", "safe_mean.Rd"),
                       compare = compare_file_text)

  expect_snapshot_file(file.path("man", "palindrome.Rd"),
                       compare = compare_file_text)
})

test_that("roclet_clean", {
  setwd("testPackage")
  on.exit(setwd(".."))

  if (length(list.files("tests/testthat", pattern = "test-doctest")) == 0L) {
    suppressMessages(roxygenise(roclets = "doctest::dt_roclet"))
  }

  expect_message(
    roclet_clean(dt_roclet(), ".")
  )

  expect_length(
    list.files("tests/testthat", pattern = "test-doctest"),
    0L
  )

  expect_length(
    list.files("tests/testthat", pattern = "test-dont-delete"),
    1L
  )
})

test_that("@omit", {
  skip_test <- "
                #' @doctest
                #' a <- 1
                #' @omit
                #'
                #' a <- 2
                #' @resume
                #' @expect equal(., 1)
                #' a
                NULL
               " |> dedent()
  results <- roc_proc_text(dt_roclet(), skip_test)
  expect_output(
    roclet_output(dt_roclet(), results),
    regexp = "a <- 1\\s+expect"
  )
})

test_that("@expectRaw", {
  raw_expectation <- "
                      #' @doctest
                      #' @expectRaw equal(2 + 2, 4)
                      NULL
                     " |> dedent()
  results <- roc_proc_text(dt_roclet(), raw_expectation)
  expect_snapshot_output(
    roclet_output(dt_roclet(), results)
  )
})

# @doctestExample

    # Generated by doctest: do not edit by hand
    # Please edit file in R/<text>
    
    test_that("example from a file", {
      # Created from @doctest for `foo`
      # Source file: <text>
      # Source line: 4
      expect_equal(1 + 1, 2)
    })
    

---

    $foo.Rd
    % Generated by roxygen2: do not edit by hand
    % Please edit documentation in ./<text>
    \name{foo}
    \alias{foo}
    \title{Title}
    \usage{
    foo()
    }
    \description{
    Title
    }
    \examples{
    1 + 1
    
    some_code_that_might_go_in_an_example()
    }
    

# Rd output

    $foo.Rd
    % Generated by roxygen2: do not edit by hand
    % Please edit documentation in ./<text>
    \name{foo}
    \alias{foo}
    \title{Title}
    \usage{
    foo()
    }
    \description{
    Title
    }
    \examples{
    x <- 1
    x
    -x
    }
    

---

    $foo.Rd
    % Generated by roxygen2: do not edit by hand
    % Please edit documentation in ./<text>
    \name{foo}
    \alias{foo}
    \title{Title}
    \usage{
    foo()
    }
    \description{
    Title
    }
    \examples{
    x <- 1
    if (x > 0) {
      x
    } else {
      -x
    }
    }
    

# dontrun

    $foo.Rd
    % Generated by roxygen2: do not edit by hand
    % Please edit documentation in ./<text>
    \docType{data}
    \name{foo}
    \alias{foo}
    \title{Title}
    \format{
    An object of class \code{numeric} of length 1.
    }
    \usage{
    foo
    }
    \description{
    Title
    }
    \keyword{datasets}
    \examples{
    \dontrun{
    stop('foo')
    }
    }
    

# @testRaw

    # Generated by doctest: do not edit by hand
    # Please edit file in R/<text>
    
    test_that("Doctest: unknown", {
      # Created from @doctest for `unknown`
      # Source file: <text>
      # Source line: 2
      skip_on_cran()
      expect_error(stop("Argh, CRAN won't like it"))
    })
    

# assignment

    # Generated by doctest: do not edit by hand
    # Please edit file in R/<text>
    
    test_that("Doctest: unknown", {
      # Created from @doctest for `unknown`
      # Source file: <text>
      # Source line: 2
      expect_equal(x <- 1, 1)
    })
    

# assignment with dot

    # Generated by doctest: do not edit by hand
    # Please edit file in R/<text>
    
    test_that("Doctest: unknown", {
      # Created from @doctest for `unknown`
      # Source file: <text>
      # Source line: 2
      expect_equal(x <- c("t", "e", "n", "e", "t"), rev(x))
    })
    

# comment

    # Generated by doctest: do not edit by hand
    # Please edit file in R/<text>
    
    test_that("Doctest: unknown", {
      # Created from @doctest for `unknown`
      # Source file: <text>
      # Source line: 2
      expect_equal(2 + 2, 4)
    })
    

# Multiple @doctest tags

    # Generated by doctest: do not edit by hand
    # Please edit file in R/<text>
    
    test_that("Doctest: unknown", {
      # Created from @doctest for `unknown`
      # Source file: <text>
      # Source line: 2
      expect_equal(x <- 1, 1)
    })
    
    test_that("Doctest: unknown", {
      # Created from @doctest for `unknown`
      # Source file: <text>
      # Source line: 6
      expect_equal(2 + 2, 4)
    })
    

# @doctest

    # Generated by doctest: do not edit by hand
    # Please edit file in R/<text>
    
    test_that("is 1 1?", {
      # Created from @doctest for `unknown`
      # Source file: <text>
      # Source line: 2
      expect_equal(1, 1)
    })
    
    test_that("is TRUE true?", {
      # Created from @doctest for `unknown`
      # Source file: <text>
      # Source line: 5
      expect_true(TRUE)
    })
    

# dontrun

    # Generated by doctest: do not edit by hand
    # Please edit file in R/<text>
    
    test_that("Doctest: unknown", {
      # Created from @doctest for `unknown`
      # Source file: <text>
      # Source line: 2
      expect_error(stop("foo"), "foo")
    })
    

# @expectation

    # Generated by doctest: do not edit by hand
    # Please edit file in R/<text>
    
    test_that("Doctest: unknown", {
      # Created from @doctest for `unknown`
      # Source file: <text>
      # Source line: 2
      expect_equal(sum(1, 1), 2)
    })
    

---

    # Generated by doctest: do not edit by hand
    # Please edit file in R/<text>
    
    test_that("Doctest: unknown", {
      # Created from @doctest for `unknown`
      # Source file: <text>
      # Source line: 2
      expect_equal(sum(1, 1), 2)
    })
    

---

    # Generated by doctest: do not edit by hand
    # Please edit file in R/<text>
    
    test_that("Doctest: unknown", {
      # Created from @doctest for `unknown`
      # Source file: <text>
      # Source line: 2
      expect_equal(1 + 1, 2)
    })
    

---

    # Generated by doctest: do not edit by hand
    # Please edit file in R/<text>
    
    test_that("Doctest: unknown", {
      # Created from @doctest for `unknown`
      # Source file: <text>
      # Source line: 2
      expect_equal(base::sum(1, 1), 2)
    })
    

---

    # Generated by doctest: do not edit by hand
    # Please edit file in R/<text>
    
    test_that("Doctest: unknown", {
      # Created from @doctest for `unknown`
      # Source file: <text>
      # Source line: 2
      expect_equal(sum(1, 1), 2)
    })
    

---

    # Generated by doctest: do not edit by hand
    # Please edit file in R/<text>
    
    test_that("Doctest: unknown", {
      # Created from @doctest for `unknown`
      # Source file: <text>
      # Source line: 2
      expect_equal(2 %plus% 2, 4)
    })
    

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/safe-arithmetic.R
\name{safe_mean}
\alias{safe_mean}
\title{Safe mean}
\usage{
safe_mean(x)
}
\arguments{
\item{x}{Numeric vector}
}
\value{
Mean of \code{x}
}
\description{
Safe mean
}
\examples{
x <- 1:3
safe_mean(x)

safe_mean("a")
safe_mean(c(1, NA))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/palindrome.R
\name{palindrome}
\alias{palindrome}
\alias{palindrome_letters}
\title{Return a palindrome}
\usage{
palindrome()

palindrome_letters()
}
\value{
A string
}
\description{
Return a palindrome
}
\examples{
p <- palindrome()

print(p)
pal_letters <- p |>
  tolower() |>
  (\(x) gsub("[^A-z]", "", x))() |>
  strsplit("") |>
  unlist()



tenet <- palindrome_letters()
}
